package com.github.jfcloud.gene.handler;

import cn.hutool.core.collection.CollUtil;
import freemarker.template.TemplateMethodModelEx;
import freemarker.template.TemplateModelException;

import java.util.List;

/**
 * freemarker自定义函数：勾选框显示
 */
public class MyCheck implements TemplateMethodModelEx {
    @Override
    public Object exec(List arguments) throws TemplateModelException {
        if (CollUtil.isEmpty(arguments)) {
            return getChecked(false);
        }
        Object content = arguments.get(0);
        if (content == null) {
            return getChecked(false);
        }
        return getChecked(Boolean.parseBoolean(content.toString()));
    }

    /**
     * 获取勾选框
     * @param checked
     * @return
     */
    public static String getChecked(boolean checked) {
        return checked ? "<w:sym w:font=\"Wingdings 2\" w:char=\"F052\" />" : "<w:sym w:font=\"Wingdings 2\" w:char=\"F0A3\" />";
    }
}
