package com.github.jfcloud.gene.sample.controller;

import cn.hutool.core.io.IoUtil;
import cn.hutool.core.io.resource.ResourceUtil;
import cn.hutool.core.net.URLEncodeUtil;
import com.github.jfcloud.gene.sample.enums.ScientificSampleTypeEnum;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.RequiredArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.InputStream;

@Slf4j
@Tag(name = "样本送检申请单")
@RestController
@RequestMapping("/sample/check/item")
@RequiredArgsConstructor
public class SampleCheckItemController {

    @Operation(summary = "送检申请单明细模板")
    @SneakyThrows
    @GetMapping("/template")
    public void downloadTemplate(@RequestParam(required = false) String type, HttpServletResponse response) {
        String template = "officeTemplate/sampleCheckItem.xlsx";
        String name = "送检申请单明细模板.xlsx";
        if (ScientificSampleTypeEnum.serum.name().equals(type)) {
            template = "officeTemplate/sampleCheckItemSerum.xlsx";
            name = "血清样本送检申请单明细模板.xlsx";
        }

        response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
        response.setCharacterEncoding("utf-8");
        response.setHeader("Content-Disposition", "attachment;filename*=utf8''" + URLEncodeUtil.encode(name));

        try (InputStream stream = ResourceUtil.getStream(template)) {
            IoUtil.copy(stream, response.getOutputStream());
        }
    }
}
