package com.github.jfcloud.gene.common.util;

import com.github.jfcloud.common.core.base.JfcloudUserInfo;
import com.github.jfcloud.common.security.service.JfcloudUser;
import com.github.jfcloud.common.security.util.SecurityUtils;
import lombok.RequiredArgsConstructor;
import lombok.extern.log4j.Log4j2;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@Log4j2
@RequiredArgsConstructor
public class UserUtil {

    private static JfcloudUserInfo getCurrentUser() {
        JfcloudUser user = SecurityUtils.getUser();
        if (user != null) {
            return user.getJfcloudUserInfo();
        }
        return new JfcloudUserInfo();
    }

    public static Long getUserId() {
        return getCurrentUser().getId();
    }

    public static String getUserName() {
        return getCurrentUser().getUsername();
    }

    public static String getNickName() {
        return getCurrentUser().getNickname();
    }

    public static Long getDeptId() {
        return getCurrentUser().getDeptId();
    }

    public static Long getTenantId() {
        return getCurrentUser().getTenantId();
    }

    public static List<Long> getRoles() {
        return SecurityUtils.getRoles();
    }
}
